Timer = Draw;

Ball ball1 = new Ball();
Ball ball2 = new Ball();

Racket racket = new Racket();

void Draw()
{
	Background(128);
	NoStroke();
	Fill(228);
	
	Rect(10, Height / 2, 20, Height);	// Wand
			
	racket.Move();
	racket.Draw();
	ball1.Move();
	ball1.Draw();
	ball2.Move();
	ball2.Draw();
	
	racket.HitBall(ball1);
	racket.HitBall(ball2);
}

class Ball
{
	double x = Random(0, Width);
	double y = Random(0, Height); 
	double speedX = 2;
	double speedY = 2;
	
	public double GetX()
	{
		return x;
	}
	public double GetY()
	{
		return y;
	}
	
	public void Start()
	{
	    speedX = 2;
    	speedY = 2;
    	x = Random(0, Width); 
    	y = Random(0, Height);
	}
	
	public void IncreaseSpeed()
	{
		speedX = speedX * -1;	

	    if(speedX < 0)
        	speedX--;
        else
        	speedX++;
	}
	
	public void Move()
	{		
		x = x + speedX;
		y = y + speedY;
		
		if(y > Height || y < 0)				// oberer/unterer Rand
	        speedY = speedY * -1;
	}
	
	public void Draw()
	{
		Circle(x, y, 50);
	}
}

class Racket
{
	double cxRacket = 20;
	double cyRacket = 150;
	double xRacket;

	public void Move()
	{
		xRacket = Width - (cxRacket / 2);
	}
	
	public void Draw()
	{
		Rect(xRacket, MouseY, cxRacket, cyRacket);
	}
	
	public void HitBall(Ball ball)
	{
		double yRacketTop    = MouseY - (cyRacket / 2);
		double yRacketBottom = MouseY + (cyRacket / 2);
		bool   hitRacket = ball.GetY() >= yRacketTop && 
		                   ball.GetY() <= yRacketBottom;
		                   
		//PrintLn($"{hitRacket}: {(int)yRacketTop} {(int)yRacketBottom}");
		
		// rechter Rand && rechter Schläger || // linke Wand
		if((ball.GetX() > Width && hitRacket == true) || ball.GetX() < 0)
		{
			if(cyRacket > 100)
				cyRacket = cyRacket - 3;
	        
	        ball.IncreaseSpeed();
		}
		
	    if(ball.GetX() > Width && hitRacket == false)	// Ball nicht getroffen
	    {
	    	ball.Start();
	    	cyRacket = 150;
	    }
	}
}



